/* LSAGPI                                       */
/* Desarrollado por Miguel Angel Pescador Santirso  */
/* mescadorsantirso@gmail.com                       */

/* LICENCIA X11/MIT
Copyright (c) 2010 Miguel Angel Pescador Santirso

Se autoriza, de forma gratuita, a cualquier
persona que ha obtenido una copia de este software y
archivos asociados de documentación (el "Software"), para tratar en el
Software sin restricción, incluyendo sin ninguna limitación en lo que concierne
los derechos para usar, copiar, modificar, fusionar, publicar,
distribuir, sublicenciar, y / o vender copias de este
Software, y para permitir a las personas que usan el Software para
hacerlo, con sujeción a las siguientes condiciones:

El aviso de copyright anterior y este aviso de permiso
se incluirá en todas las copias o partes sustanciales de
este Software.

EL SOFTWARE SE ENTREGA "TAL CUAL", SIN GARANTÍA DE NINGÚN
TIPO, EXPRESA o implícita, no limitado a la GARANTÍAS DE
COMERCIALIZACIÓN, CAPACIDAD DE HACER Y DE NO INFRACCIÓN DE COPYRIGHT. EN NINGÚN
CASO LOS AUTORES O TITULARES DEL COPYRIGHT SERÁN RESPONSABLES DE
NINGUNA RECLAMACIÓN, daños o OTRAS RESPONSABILIDADES,
YA SEA EN UN LITIGIO, agravio o DE OTRO MODO,
DERIVADAS DE, FUERA DE O EN CONEXION CON EL
SOFTWARE SU UTILIZACIÓN U OTRAS OPERACIONES EN EL SOFTWARE.
*/



package lsagpi;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.image.BufferedImage;
import java.util.Random;
import java.util.Vector;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JPanel;

/**
 * Clase que ejecuta las acciones.
 * @author Miguel Angel Pescador Santirso
 */
public class EjecutarAcciones extends Thread{
final int DI=0;
final int MOVER=1;
final int GIRAR=2;
final int ESPERAR=3;
final int SALIR=4;
final int SELECCIONARPOSICION=5;
final int SELECCIONARTINTA=6;
final int SELECCIONARETIQUETA=7;
final int SELECCIONARJUGADOR=8;
final int DORMIR=9;
final int CAMINAR=10;
final int SALTAR=11;
final int SI=12;
final int ENTONCES=13;
final int OTRO=14;
final int MIENTRAS=15;
final int PARA=16;
final int COLOCAR=17;
final int LOCALIZAR=18;
final int DAR=19;
final int ACTIVARPANEL=20;
final int LIMPIARPANEL=21;
final int ADDPREGUNTA=22;
final int ESPERARESPUESTA=23;
final int SELECCIONARACTITUD=24;
final int SELECCIONARANIMACION=25;
final int LLAMAPROCEDIMIENTO=26;
final int TRANSICION=27;
final int COGER=28;
//Operaciones sobre variables
final int ADD=301;
final int ADDV=302;
final int LET=303;
final int MULT=304;
final int RAND=305;
    Vector elementos;
    Sistema sis;
    boolean hablando=false;
    String personaje;
    Cuarto habi;
    /**
     * Constructor de la Clase  ejecuar acciones.
     * @param sistema Valores del sistema.
     * @param acciones Acciones a ejecutar
     * @param room habitaciones del juego.
     * @param g cursor de graficos.
     * @param propietario clase desde la que es llamado.
     */
    @SuppressWarnings("static-access")
    public EjecutarAcciones(Sistema sistema, Vector acciones,Vector room, Graphics g, final JPanel propietario){
        for(int f=0;f<room.size();f++){
            if(((Cuarto)room.get(f)).nombre.equals(sistema.habitacionInicial)){
                habi=(Cuarto)room.get(f);
            }
        }
        elementos=habi.elementos;
        sis=sistema;
        Vector accion;
        
        for(int i=0;i<acciones.size();i++){
            
            accion=(Vector)acciones.get(i);
            //System.out.println(accion.get(0).toString());
            int clase=Integer.parseInt(accion.get(0).toString());
            switch(clase){

                    case DI://Seleccionar elemento y calcular posicion de texto
                       System.out.println("Instruccion DI");
                        personaje=accion.get(1).toString().trim();
                        int tinta=-1;
                        int[] pos=new int[3];
                        int alto=0;
                        for(int j=0;j<elementos.size();j++){
                            Elemento ele=(Elemento)elementos.get(j);
                            if(personaje.equals(ele.nombre.trim())){
                                pos=ele.getPosicion();
                                alto=ele.getImagen().getHeight(null);
                                if(ele.tinta!=-1){
                                    tinta=ele.tinta;
                                }
                             }
                        }
                        final int posx=pos[0];
                        int escalaAlto=0;
                        if(pos[2]!=0){
                            double esc=((double)pos[2])/100;
                            escalaAlto = (int)( esc*alto );
                        }else{escalaAlto=pos[1]-alto;}
                        final int posy=escalaAlto;
                        final int tin=tinta;
                        final String texto=accion.get(2).toString();
                        while (hablando){
                            try {
                                        sleep( 250 );
                                    } catch( InterruptedException e ) {
                                }
                        }
                        //Dibujar Texto, esperar 2 segundos y borrarlo
                        Runnable miRunnableDi = new Runnable()
                        {
                        public void run()
                        {

                        hablando=true;
                        Graphics h=propietario.getGraphics();
                        h.setFont(sis.fuente);
                        h.setColor(Color.GREEN);
                        if(tin!=-1){
                            switch(tin){
                                case 0:h.setColor(Color.BLACK);
                                break;
                                case 1:h.setColor(Color.BLUE);
                                break;
                                case 2:h.setColor(Color.RED);
                                break;
                                case 3:h.setColor(Color.PINK);
                                break;
                                case 4:h.setColor(Color.GREEN);
                                break;
                                case 5:h.setColor(Color.CYAN);
                                break;
                                case 6:h.setColor(Color.YELLOW);
                                break;
                                case 7:h.setColor(Color.WHITE);
                                break;
                                case 8:h.setColor(Color.GRAY);
                                break;
                                case 9:h.setColor(Color.ORANGE);
                                break;
                            }
                        }
                        h.drawString(texto, posx-10, posy-10);
                        h.dispose();
                        System.out.println(personaje+" : "+texto);

                        //propietario.update(propietario.getGraphics());
                       try {
                                        sleep( 2500 );
                                    } catch( InterruptedException e ) {
                                }
                        propietario.update(propietario.getGraphics());
                        hablando=false;
                        
                         }
                         };
                        Thread hilo = new Thread (miRunnableDi);
                        hilo.start();

                        break;
                    case MOVER:System.out.println("Instruccion Mover");
                    final int posFinX=Integer.parseInt(accion.get(2).toString());
                    final int posFinY=Integer.parseInt(accion.get(3).toString());
                    final int posFinZ=Integer.parseInt(accion.get(4).toString());

                    personaje=accion.get(1).toString().trim();
                    while (hablando){
                            try {
                                        sleep( 250 );
                                    } catch( InterruptedException e ) {
                                }
                        }
                       Runnable miRunnableAndar = new Runnable()
                        {
                        public void run()
                        {
                         
                         hablando=true;
                       for(int j=0;j<elementos.size();j++){
                           BufferedImage bufferedImage;
                           Color mascolor;
                           Elemento ele=(Elemento)elementos.get(j);
                           mascolor=Color.WHITE;
                           bufferedImage = new BufferedImage( sis.PANTALLAHORIZONTAL,sis.PANTALLAVERTICAL,BufferedImage.TYPE_INT_RGB );

                           if(habi.getMascara()!=null){
                                    Image mascara=habi.getMascara().getImage();
                                    int alto=mascara.getHeight(null);
                                    int ancho=mascara.getWidth(null);
                                    if(alto>sis.PANTALLAVERTICAL){
                                        alto=alto-sis.PANTALLAVERTICAL;
                                    }else{alto=0;}
                                    if(ancho>sis.PANTALLAHORIZONTAL){
                                        ancho=0;//ancho-sis.PANTALLAHORIZONTAL;
                                    }else{ancho=0;}
                                    Graphics masgra = bufferedImage.createGraphics();
                                    masgra.drawImage(mascara,-ancho,-alto,null);
                                    masgra.dispose();
                                    mascolor=new Color(bufferedImage.getRGB(posFinX,posFinY));
                                }
                                if(mascolor.equals(Color.BLACK)){
                                    if(personaje.equals(ele.nombre.trim())){
                                            int[] posi=new int[3];
                                            posi=ele.getPosicion();
                                            Graphics h=propietario.getGraphics();
                                            h.setFont(sis.fuente);
                                            h.setColor(Color.GREEN);
                                            //Ajustar altura del texto.
                                            h.drawString("No puedo ir ahi", posi[0]-10, posi[1]-ele.getImagen().getHeight(null)-10);
                                            h.dispose();
                                            try {
                                        sleep( 2500 );
                                    } catch( InterruptedException e ) {
                                }
                                propietario.update(propietario.getGraphics());
                                    }
                                }
                                if(mascolor.equals(Color.WHITE)){


                            
                            if(personaje.equals(ele.nombre.trim())){
                                int[] posi=new int[3];
                                posi=ele.getPosicion();
                                Image elementoImagen=ele.getImagen();
                                int posH=elementoImagen.getHeight(propietario);
                                int posW=elementoImagen.getWidth(propietario);
                                int posHsinescala=posH;
                                int OFFSET=1;
                                
                                                            
                                while(posi[0]!=posFinX || posi[1]!=posFinY){
                                    //System.out.println(posi[0]+"+"+posi[1]+" Final "+posFinX+":"+posFinY);
                                    if(posi[2]!=0){
                                        //System.out.println("escala");
                                        double esc=((double)posi[2])/100;
                                        posH=(int)esc*posH;
                                        posW=(int)esc*posW;
                                    }

                                   if(posFinX>posi[0]){
                                       /*if(habi.getMascara()!=null){
                                        mascolor=new Color(bufferedImage.getRGB(posi[0]++OFFSET, posi[1]));
                                       }
                                       if(mascolor.equals(Color.WHITE)||habi.getMascara()==null){*/
                                        posi[0]=posi[0]+OFFSET;
                                        ele.setPosicion(posi[0],posi[1],posi[2]);
                                        try { sleep( 1000/sis.fps ); } catch( InterruptedException e ) {}
                                        ele.animacion.possprite++;
                                        ele.animacion.imagenamostrar=5;
                                        propietario.update(propietario.getGraphics());
                                       //}
                                    }else if(posFinX<posi[0]){
                                      /*  if(habi.getMascara()!=null){
                                        mascolor=new Color(bufferedImage.getRGB(posi[0]-OFFSET, posi[1]));
                                       }
                                       if(mascolor.equals(Color.WHITE)||habi.getMascara()==null){*/
                                        posi[0]=posi[0]-OFFSET;
                                        ele.setPosicion(posi[0],posi[1],posi[2]);
                                        try { sleep( 1000/sis.fps ); } catch( InterruptedException e ) {}
                                        ele.animacion.possprite++;
                                        ele.animacion.imagenamostrar=7;
                                        propietario.update(propietario.getGraphics());
                                      // }
                                    }else if(posFinY>posi[1]){
                                      /*  if(habi.getMascara()!=null){
                                         mascolor=new Color(bufferedImage.getRGB(posi[0], posi[1]+OFFSET));
                                       }
                                       if(mascolor.equals(Color.WHITE)||habi.getMascara()==null){*/
                                        posi[1]=posi[1]+OFFSET;
                                        ele.setPosicion(posi[0],posi[1],posi[2]);
                                        try { sleep( 1000/sis.fps ); } catch( InterruptedException e ) {}
                                        ele.animacion.possprite++;
                                        ele.animacion.imagenamostrar=4;
                                        propietario.update(propietario.getGraphics());
                                      // }
                                    }else if(posFinY<posi[1]){
                                        /*if(habi.getMascara()!=null){
                                         mascolor=new Color(bufferedImage.getRGB(posi[0], posi[1]-OFFSET));
                                       }
                                       if(mascolor.equals(Color.WHITE)||habi.getMascara()==null){*/
                                        posi[1]=posi[1]-OFFSET;
                                        ele.setPosicion(posi[0],posi[1],posi[2]);
                                        try { sleep( 1000/sis.fps ); } catch( InterruptedException e ) {}
                                        ele.animacion.possprite++;
                                        ele.animacion.imagenamostrar=6;
                                        propietario.update(propietario.getGraphics());
                                    }//}
                                    try {
                                        sleep( 1000/sis.fps );
                                    } catch( InterruptedException e ) {
                                }
                                   
                            }
                            ele.animacion.imagenamostrar=0;
                            propietario.update(propietario.getGraphics());
                            hablando=false;
                            }}
                            }
                       }

                         
                         };
                        Thread hilo2 = new Thread (miRunnableAndar);
                        hilo2.start();
                        
                        break;
                    case GIRAR:System.out.println("Instrucción GIRAR");
                                Elemento personaje1=null;
                                Elemento personaje2=null;
                                for(int j=0;j<elementos.size();j++){
                                    if (((Elemento)elementos.elementAt(j)).nombre.equals(accion.get(1).toString()))
                                        personaje1=((Elemento)elementos.elementAt(j));
                                }
                                for(int j=0;j<elementos.size();j++){
                                    if (((Elemento)elementos.elementAt(j)).nombre.equals(accion.get(2).toString()))
                                        personaje2=((Elemento)elementos.elementAt(j));
                                }
                                if( personaje1.posicion[0]< personaje2.posicion[0]){
                                    personaje1.animacion.imagenamostrar=1;
                                    propietario.update(propietario.getGraphics());
                                }else{
                                    personaje1.animacion.imagenamostrar=3;
                                    propietario.update(propietario.getGraphics());
                                }
                                hablando=false;
                        break;
                    case ESPERAR:System.out.println("Instruccion Esperar");
                        /*Runnable miRunnableEsperar = new Runnable()
                        {
                        public void run()
                        {*/
                            while(hablando==true ){
                            try {sleep( 250 );} catch( InterruptedException e ) {}
                                }
                            propietario.update(propietario.getGraphics());
                         /*}
                         };
                        Thread hilo4 = new Thread (miRunnableEsperar);
                        hilo4.start();(*/
                        break;
                case SALIR: System.exit(0);
                    break;
                case SELECCIONARPOSICION:
                    personaje=accion.get(1).toString().trim();
                    int posFinX2=Integer.parseInt(accion.get(2).toString());
                    int posFinY2=Integer.parseInt(accion.get(3).toString());
                    int posFinZ2=Integer.parseInt(accion.get(4).toString());
                    for(int j=0;j<elementos.size();j++){
                            Elemento ele=(Elemento)elementos.get(j);
                            if(personaje.equals(ele.nombre.trim())){
                                ele.setPosicion(posFinX2,posFinY2,posFinZ2);
                            }
                    }
                    break;
                case SELECCIONARTINTA: personaje=accion.get(1).toString().trim();
                    int tintasel=Integer.parseInt(accion.get(2).toString());
                    for(int j=0;j<elementos.size();j++){
                            Elemento ele=(Elemento)elementos.get(j);
                            if(personaje.equals(ele.nombre.trim())){
                                ele.tinta=tintasel;
                            }
                    }
                    break;
                 case SELECCIONARETIQUETA: personaje=accion.get(1).toString().trim();
                    for(int j=0;j<elementos.size();j++){
                            Elemento ele=(Elemento)elementos.get(j);
                            if(personaje.equals(ele.nombre.trim())){
                                ele.nombre=accion.get(2).toString();
                            }
                    }
                    break;
                case SELECCIONARJUGADOR:
                    sis.personaje=accion.get(1).toString().trim();
                    propietario.update(propietario.getGraphics());
                    //Hacer cambio de habitacion si es necesario
                    //Por Implementar
                    break;
                case DORMIR: int ms=Integer.parseInt(accion.get(1).toString().trim());
                    try { sleep( ms );} catch( InterruptedException e ) {}
                    break;
                case CAMINAR:System.out.println("Instruccion CAMINAR");
                    personaje=accion.get(1).toString().trim();
                    final int posFinX3=Integer.parseInt(accion.get(2).toString());
                    final int posFinY3=Integer.parseInt(accion.get(3).toString());
                    while (hablando==true){
                            try {
                                        sleep( 1000/sis.fps  );
                                    } catch( InterruptedException e ) {
                                }
                        }
                    Runnable miRunnableCaminar = new Runnable()
                        {
                        public void run()
                        {
                         
                         hablando=true;
                       for(int j=0;j<elementos.size();j++){
                            Elemento ele=(Elemento)elementos.get(j);
                            if(personaje.equals(ele.nombre.trim())){
                                int[] posi=new int[3];
                                posi=ele.getPosicion();
                                Image elementoImagen=ele.getImagen();
                                int posH=elementoImagen.getHeight(propietario);
                                int posW=elementoImagen.getWidth(propietario);
                                int OFFSET=1;

                                while(posi[0]!=posFinX3 || posi[1]!=(posFinY3-(posH-10))){
                                    //System.out.println(posi[0]+"+"+posi[1]+" Final "+posFinX+":"+posFinY);
                                    if(posFinX3>posi[0]){
                                        posi[0]=posi[0]+OFFSET;
                                        ele.setPosicion(posi[0],posi[1],0);
                                        propietario.update(propietario.getGraphics());
                                    }
                                    if(posFinX3<posi[0]){
                                        posi[0]=posi[0]-OFFSET;
                                        ele.setPosicion(posi[0],posi[1],0);
                                        propietario.update(propietario.getGraphics());
                                    }
                                    if((posFinY3-(posH-10))>posi[1]){
                                        posi[1]++;
                                        ele.setPosicion(posi[0],posi[1],0);
                                        propietario.update(propietario.getGraphics());
                                    }
                                    if((posFinY3-(posH-10))<posi[1]){
                                        posi[1]--;
                                        ele.setPosicion(posi[0],posi[1],0);
                                        propietario.update(propietario.getGraphics());
                                    }
                                    try {
                                        sleep( 10 );
                                    } catch( InterruptedException e ) {
                                }

                            }
                            hablando=false;
                            }
                       }

                         }
                         };
                        Thread hilo5 = new Thread (miRunnableCaminar);
                        hilo5.start();

                        break;
                case SALTAR://Cambiar habitacion actual
                    System.out.println("Instruccion SALTAR");
                    sis.habitacionInicial=accion.get(1).toString().trim();
                    propietario.update(propietario.getGraphics());
                    break;
                case SI:System.out.println("Instruccion SI-ENTONCES-OTRO");
                        Comparar condicionsi=new Comparar((Vector)accion.get(1),habi);
                        System.out.println("Tamaño de la accion = "+accion.size());
                        
                        if(condicionsi.getResultado()){
                            new EjecutarAcciones(sis, (Vector) accion.get(2), room, g, propietario);
                        }/*else{
                            // Comprobamos que efectivamente existe el bloque OTRO.
                            try{
                                EjecutarAcciones accionotro=new EjecutarAcciones(sis, (Vector) accion.get(3), room, g, propietario);
                            }catch(ArrayIndexOutOfBoundsException aioobe){}
                        }*/
                    break;
                case ENTONCES:break;
                case OTRO:break;
                case MIENTRAS:System.out.println("Instruccion MIENTRAS-ENTONCES");
                    final Vector vec1mientras=(Vector)accion.get(1);
                    final Vector vec2mientras=(Vector) accion.get(2);
                    final Vector vec3mientras=room;
                    final Graphics ggmientras=g;
                    
                    Runnable miRunnableER = new Runnable()
                        {
                        public void run()
                        {  
                    Comparar condicionmientras=new Comparar(vec1mientras,habi);
                    while(condicionmientras.getResultado()){
                        new EjecutarAcciones(sis, vec2mientras, vec3mientras, ggmientras, propietario);
                        System.out.println("Condicion salida Mientras: "+condicionmientras.getResultado());
                    }
                    } };
                        Thread hilo8 = new Thread (miRunnableER);
                        hilo8.start();
                    break;
                case PARA:System.out.println("PARA-ENTONCES");
                    break;
                case COLOCAR: //Colocar personaje en nueva habitacion
                        for(int f=0;f<room.size();f++){
                              if(((Cuarto)room.get(f)).nombre.equals(sistema.habitacionInicial)){
                                habi=(Cuarto)room.get(f);
                                }
                        }
                        habi.elementos.add(sis.personajeelemento);
                        propietario.update(propietario.getGraphics());
                        break;
                case LOCALIZAR:sis.personajeelemento.setPosicion(Integer.parseInt(accion.get(2).toString()), Integer.parseInt(accion.get(3).toString()), Integer.parseInt(accion.get(4).toString()));
                    break;
                case DAR: System.out.println("Instruccion Dar");
                    Elemento personajedar=null;
                    Elemento objeto=null;
                    for(int j=0;j<elementos.size();j++){
                        if (((Elemento)elementos.elementAt(j)).nombre.equals(accion.get(1).toString()))
                            personajedar=((Elemento)elementos.elementAt(j));
                        }
                    for(int j=0;j<elementos.size();j++){
                            if (!((Elemento)elementos.elementAt(j)).elementos.isEmpty())
                                for(int k=0;k<((Elemento)elementos.elementAt(j)).elementos.size();k++){
                                    if (((Elemento)((Elemento)elementos.elementAt(j)).elementos.elementAt(k)).nombre.equals(accion.get(2).toString()))
                                        objeto=(Elemento)((Elemento)elementos.elementAt(j)).elementos.elementAt(k);
                                        personajedar.elementos.add(objeto);
                                        ((Elemento)elementos.elementAt(j)).elementos.removeElementAt(k);
                                }
                    }
                    propietario.update(propietario.getGraphics());
                    break;
                case ACTIVARPANEL: System.out.println("ActivarPanel ");
                    if(Integer.parseInt(accion.get(1).toString())==1){
                                        sis.paneldeconversacion=true;
                                    }else{sis.paneldeconversacion=true;}
                                    propietario.update(propietario.getGraphics());
                                break;
                case ESPERARESPUESTA:System.out.println("EsperarRespuesta ");
                        String nombrevarER=accion.get(1).toString();
                        
                        System.out.println("Respuesta: "+sis.panelconversacion.opcionseleccionada);
                        if(sis.panelconversacion.getOpcion()!=0){
                            for(int j=0;j<habi.elementos.size();j++){
                                Vector vari=((Elemento)habi.elementos.elementAt(j)).variables;
                                int entero=sis.panelconversacion.opcionseleccionada;
                                for (int k=0;k<vari.size();k++){
                                    if (nombrevarER.equals(vari.get(k).toString())){
                                        System.out.println("Variable encontrada: "+nombrevarER);
                                        vari.set(k+1,entero);
                                    }
                                 }
                            }
                            sis.panelconversacion.opcionseleccionada=0;
                        }
                    break;
                case LIMPIARPANEL:System.out.println("LimpiarPanel");
                    sis.panelconversacion.limpiarPanel();
                    propietario.update(propietario.getGraphics());
                            break;
                case ADDPREGUNTA:System.out.println("Addrespuesta "+accion.get(1).toString()+" "+Integer.parseInt(accion.get(2).toString()));
                    sis.panelconversacion.addRespuesta(accion.get(1).toString(), Integer.parseInt(accion.get(2).toString()));
                    propietario.update(propietario.getGraphics());
                        break;
                case SELECCIONARACTITUD:
                            try {
                                        sleep( 2500 );
                                    } catch( InterruptedException e ) {
                                }
                        
                        personaje=accion.get(1).toString().trim();
                        int actitud=Integer.parseInt(accion.get(2).toString().trim());
                        for(int j=0;j<elementos.size();j++){
                            Elemento ele=(Elemento)elementos.get(j);
                            if(personaje.equals(ele.nombre.trim())){
                                if(actitud==3){ele.animacion.personalizada=true;}
                                if(actitud==0){ele.animacion.personalizada=false;}
                             }
                        }
                        propietario.update(propietario.getGraphics());
                    break;
                case SELECCIONARANIMACION:
                        personaje=accion.get(1).toString().trim();
                        int frames=Integer.parseInt(accion.get(5).toString().trim());
                        for(int j=0;j<elementos.size();j++){
                            Elemento ele=(Elemento)elementos.get(j);
                            if(personaje.equals(ele.nombre.trim())){
                                ele.animacion.addActitud(accion.get(4).toString().trim(), frames);
                            }
                            }
                    break;
                case LLAMAPROCEDIMIENTO:
                    break;
                case TRANSICION:
                    break;
                case COGER: System.out.println("Instruccion Coger");
                    Elemento personajecoger=null;
                    Elemento objeto2=null;
                    for(int j=0;j<elementos.size();j++){
                        if (((Elemento)elementos.elementAt(j)).nombre.equals(accion.get(1).toString()))
                            personajecoger=((Elemento)elementos.elementAt(j));
                        }
                    //Probar
                    for(int j=0;j<elementos.size();j++){
                                if (((Elemento)elementos.elementAt(j)).nombre.equals(accion.get(2).toString())){
                                        personajecoger.elementos.add((Elemento)elementos.remove(j));
                                }
                    }
                    propietario.update(propietario.getGraphics());
                    break;
                case ADD:for(int j=0;j<habi.elementos.size();j++){
                        Vector vari=((Elemento)habi.elementos.elementAt(j)).variables;
                        String nombrevar=accion.get(1).toString();
                        System.out.println("Vari Tamaño: "+vari.size());
                        System.out.println("Accion1: "+accion.get(1).toString());
                        System.out.println("Accion2: "+accion.get(2).toString());
                        int entero=(new Integer(accion.get(2).toString())).intValue();
                        for (int k=0;k<vari.size();k++){
                            if (nombrevar.equals(vari.get(k).toString())){
                                System.out.println("Variable encontrada: "+vari.get(k).toString()+"Iteracion="+k);
                                vari.set(k+1,(new Integer(vari.get(k+1).toString())).intValue()+entero);
                                System.out.println("Variable encontrada: "+vari.get(k).toString()+"Valor actualizado="+vari.get(k+1).toString());
                            }
                            }
                    }
                    break;
                case ADDV:break;
                case LET:for(int j=0;j<habi.elementos.size();j++){
                        Vector vari=((Elemento)habi.elementos.elementAt(j)).variables;
                        String nombrevar=accion.get(1).toString();
                        int entero=(new Integer(accion.get(2).toString())).intValue();
                        for (int k=0;k<vari.size();k++){
                            if (nombrevar.equals(vari.get(k).toString())){
                                System.out.println("Variable encontrada: "+nombrevar);
                                vari.set(k+1,entero);
                            }
                            }
                    }
                    break;
                case MULT:for(int j=0;j<habi.elementos.size();j++){
                        Vector vari=((Elemento)habi.elementos.elementAt(j)).variables;
                        String nombrevar=accion.get(1).toString();
                        int entero=(new Integer(accion.get(2).toString())).intValue();
                        for (int k=0;k<vari.size();k++){
                            if (nombrevar.equals(vari.get(k).toString())){
                                System.out.println("Variable encontrada: "+nombrevar);
                                vari.set(k+1,(new Integer(vari.get(k+1).toString())).intValue()*entero);
                            }
                            }
                    }
                    break;
                case RAND:for(int j=0;j<habi.elementos.size();j++){
                        Vector vari=((Elemento)habi.elementos.elementAt(j)).variables;
                        String nombrevar=accion.get(1).toString();
                        int entero=(new Random()).nextInt(1000);
                        for (int k=0;k<vari.size();k++){
                            if (nombrevar.equals(vari.get(k).toString())){
                                System.out.println("Variable encontrada: "+nombrevar);
                                vari.set(k+1,entero);
                            }
                            }
                    }
                    break;

                }
            
        }
        }
    /**
     * Ejecucion en hilo aparte.
     */
    @Override
    public void run(){

    }
}
