/* LSAGPI                                       */
/* Desarrollado por Miguel Angel Pescador Santirso  */
/* mescadorsantirso@gmail.com                       */

/* LICENCIA X11/MIT
Copyright (c) 2010 Miguel Angel Pescador Santirso

Se autoriza, de forma gratuita, a cualquier
persona que ha obtenido una copia de este software y
archivos asociados de documentación (el "Software"), para tratar en el
Software sin restricción, incluyendo sin ninguna limitación en lo que concierne
los derechos para usar, copiar, modificar, fusionar, publicar,
distribuir, sublicenciar, y / o vender copias de este
Software, y para permitir a las personas que usan el Software para
hacerlo, con sujeción a las siguientes condiciones:

El aviso de copyright anterior y este aviso de permiso
se incluirá en todas las copias o partes sustanciales de
este Software.

EL SOFTWARE SE ENTREGA "TAL CUAL", SIN GARANTÍA DE NINGÚN
TIPO, EXPRESA o implícita, no limitado a la GARANTÍAS DE
COMERCIALIZACIÓN, CAPACIDAD DE HACER Y DE NO INFRACCIÓN DE COPYRIGHT. EN NINGÚN
CASO LOS AUTORES O TITULARES DEL COPYRIGHT SERÁN RESPONSABLES DE
NINGUNA RECLAMACIÓN, daños o OTRAS RESPONSABILIDADES,
YA SEA EN UN LITIGIO, agravio o DE OTRO MODO,
DERIVADAS DE, FUERA DE O EN CONEXION CON EL
SOFTWARE SU UTILIZACIÓN U OTRAS OPERACIONES EN EL SOFTWARE.
*/



package lsagpi;

import java.awt.Image;
import java.util.StringTokenizer;
import java.util.Vector;
import javax.swing.ImageIcon;

/**
 * Clase de elemento.
 * @author Miguel Angel Pescador Santirso
 */
public class Elemento implements Cloneable{
final int ENTERO=0;
final int CADENA=1;
final int CUARTOVAR=2;
final int ELEMENTVAR=3;
String nombre;
Vector elementos=new Vector();
Animacion animacion;
int[] posicion=new int[3];
ImageIcon icono;
ImageIcon imagen;
int[] accionimagen=new int[2];
int tinta=-1;
Vector acciones=new Vector();
String verbodefecto;
Vector variables=new Vector();

/**
 * Constructor del elemento.
 * @param definicion Definicion del elemento.
 * @param nom Nombre del elemento.
 */
public Elemento(String definicion,String nom){
    this.parsear(definicion, nom);
}
/**
 * Método que parsea la definicion, util para la herencia.
 * @param definicion Definicion del elemento.
 * @param nom Nombre del elemento.
 */
public void parsear(String definicion, String nom){
    nombre=nom;
    StringTokenizer st = new StringTokenizer(definicion,"\n",true);
        //nombre=st.nextToken();
        while (st.hasMoreTokens())
		{
            String cadena=st.nextToken();
            if(cadena.indexOf("ELEMENTO")!=-1){
                System.out.println("Un elemento");
                StringTokenizer nom_tok=new StringTokenizer(cadena);
                String nomb=new String("");
                if(nom_tok.nextToken().equals("ELEMENTO")){
                    nomb=nom_tok.nextToken();
                }
                String superclase=null;
                if(nom_tok.hasMoreTokens())
                        nomb=nom_tok.nextToken();
                if(nomb.equals("EXTIENDE")){
                    superclase=nom_tok.nextToken();
                }
                String elemento=new String("");
                while(cadena.indexOf("{")==-1){
                    cadena=st.nextToken();
                }
                cadena=st.nextToken();
                int contador=0;
                elemento+=cadena;
                while( contador!=(-1) && st.hasMoreTokens()){
                       String cadena_contador=st.nextToken();
                       elemento+=cadena_contador;
                       if(cadena_contador.indexOf("{")!=-1){
                           contador++;
                           elemento+=cadena_contador;
                       }
                       if(cadena_contador.indexOf("}")!=-1){
                           contador--;
                           elemento+=cadena_contador;
                       }
                    }
                    if(superclase==null){
                   elementos.add(new Elemento(elemento,nomb));
                }else{
                    elementos.add(new Elemento(elemento,nomb));
                }
                    }
            if(cadena.indexOf("INSTRUCCION")!=-1){
                System.out.println("Una instruccion de personaje");
                String instruccion=new String("");
                int contador=0;

                instruccion+=cadena;
                while( contador!=(-1) && st.hasMoreTokens()){
                       String cadena_contador=st.nextToken();
                       instruccion+=cadena_contador;
                       if(cadena_contador.indexOf("{")!=-1){
                           contador++;
                           instruccion+=cadena_contador;
                       }
                       if(cadena_contador.indexOf("}")!=-1){
                           contador--;
                            if(contador==0){
                               contador--;
                           }
                           instruccion+=cadena_contador;
                       }
                    }
                    acciones.add(new Accion(instruccion));
           }
            if(cadena.indexOf("ANIMACION")!=-1){
                System.out.println("Una animacion");
                String anima=new String("");
                while(cadena.indexOf("{")==-1){
                    cadena=st.nextToken();
                }
                cadena=st.nextToken();
                int contador=0;
                anima+=cadena;
                while( contador!=(-1) && st.hasMoreTokens()){
                       String cadena_contador=st.nextToken();
                       anima+=cadena_contador;
                       if(cadena_contador.indexOf("{")!=-1){
                           contador++;
                           anima+=cadena_contador;
                       }
                       if(cadena_contador.indexOf("}")!=-1){
                           contador--;
                           anima+=cadena_contador;
                       }
                    }
                    animacion =new Animacion(anima);
                    }
            if(cadena.indexOf("POSICION")!=-1){
                System.out.println("Una posicion");
                StringTokenizer num_tok=new StringTokenizer(cadena," ");
                String num=new String("");
                while(num_tok.hasMoreTokens()){
                    num=num_tok.nextToken();
                    if(num.equals("POSICION"));
                    if(num.equals("{")){

                        posicion[0]=Integer.parseInt(num_tok.nextToken());
                        posicion[1]=Integer.parseInt(num_tok.nextToken());
                        posicion[2]=Integer.parseInt(num_tok.nextToken());
                    }

                }

            }
            if(cadena.indexOf("IMAGEN")!=-1){
                System.out.println("Una imagen");
                while(cadena.indexOf("\"")==-1){
                    cadena=st.nextToken();
                }
                StringTokenizer icon_tok=new StringTokenizer(cadena,"\"");
                if(cadena.indexOf("{")!=-1 && cadena.indexOf("{")!=-1){
                    icon_tok.nextToken();
                    imagen=new ImageIcon(icon_tok.nextToken());
                }else{

                while(icon_tok.hasMoreTokens()){
                    String temp=icon_tok.nextToken();
                    if(temp.trim().indexOf("{")!=-1){
                        while(temp.trim().isEmpty() && icon_tok.hasMoreTokens())
                                temp=icon_tok.nextToken();
                        imagen=new ImageIcon(temp);
                    }else{
                        while(temp.trim().isEmpty() && icon_tok.hasMoreTokens())
                                temp=icon_tok.nextToken();
                        imagen=new ImageIcon(temp);
                        }

                }}
                System.out.println(imagen.toString());
            }
            if(cadena.indexOf("ICONO")!=-1){
                System.out.println("Un icono");
                StringTokenizer icon_tok=new StringTokenizer(cadena,"\"");
                while(icon_tok.hasMoreTokens()){
                    if(icon_tok.nextToken().indexOf("ICONO {")>-1){
                        icono=new ImageIcon(icon_tok.nextToken());
                    }

                }

            }
            if(cadena.indexOf("VERBODEFECTO")!=-1){
                System.out.println("Verbo por defecto");
                StringTokenizer verb_tok=new StringTokenizer(cadena," ");
                while(verb_tok.hasMoreTokens()){
                    String token=verb_tok.nextToken();
                    while(token.indexOf("{")==-1 && verb_tok.hasMoreTokens()){
                        token=verb_tok.nextToken();
                    }

                    if(token.indexOf("{")!=-1 && verb_tok.hasMoreTokens()){
                        verbodefecto=verb_tok.nextToken();
                    }

                }
                System.out.println(verbodefecto);
            }
            if(cadena.indexOf("TINTA")!=-1){
                System.out.println("Una tinta");
                StringTokenizer icon_tok=new StringTokenizer(cadena,"{");
                while(icon_tok.hasMoreTokens()){
                    if(icon_tok.nextToken().indexOf("TINTA")!=-1){
                        String color=icon_tok.nextToken();
                        tinta=Integer.parseInt(color.substring(0,color.indexOf("}")-1).trim());
                    }

                }
                System.out.println("Tinta color: "+tinta);
            }
            //Parte de Variables
            if(cadena.indexOf("VARIABLE")!=-1){

            }
            if(cadena.indexOf("ENTERO")!=-1){
                System.out.println("Un entero");
                StringTokenizer num_tok=new StringTokenizer(cadena," ");
                String num=new String("");
                //Vector expresion=new Vector();
                while(num_tok.hasMoreTokens()){
                    num=num_tok.nextToken();
                    if(num.equals("ENTERO"));
                    if(num.equals("{") && num_tok.hasMoreTokens()){
                        variables.add(num_tok.nextToken().trim());
                        variables.add(0);
                    }
                    if (num.equals("{") && !num_tok.hasMoreTokens()){
                        cadena=st.nextToken();
                        StringTokenizer num2_tok=new StringTokenizer(cadena);
                        variables.add(num2_tok.nextToken().trim());
                        variables.add(0);
                    }

                }

            }
              if(cadena.indexOf("CADENA")!=-1){
                System.out.println("Una cadena");
                StringTokenizer num_tok=new StringTokenizer(cadena," ");
                String num=new String("");
                Vector expresion=new Vector();
                while(num_tok.hasMoreTokens()){
                    num=num_tok.nextToken();
                    if(num.equals("CADENA"));
                    if(num.equals("{") && num_tok.hasMoreTokens()){
                        expresion.add(CADENA);
                        expresion.add(num_tok.nextToken());
                        expresion.add("");
                    }
                    if (num.equals("{") && !num_tok.hasMoreTokens()){
                        cadena=st.nextToken();
                        StringTokenizer num2_tok=new StringTokenizer(cadena);
                        expresion.add(CADENA);
                        expresion.add(num2_tok.nextToken());
                        expresion.add("");
                    }

                }
                variables.add(expresion);
            }
             if(cadena.indexOf("CUARTOVAR")!=-1){
                System.out.println("Un variable de cuarto");
                StringTokenizer num_tok=new StringTokenizer(cadena," ");
                String num=new String("");
                Vector expresion=new Vector();
                while(num_tok.hasMoreTokens()){
                    num=num_tok.nextToken();
                    if(num.equals("CUARTOVAR"));
                    if(num.equals("{") && num_tok.hasMoreTokens()){
                        expresion.add(CUARTOVAR);
                        expresion.add(num_tok.nextToken());
                        expresion.add("");
                    }
                    if (num.equals("{") && !num_tok.hasMoreTokens()){
                        cadena=st.nextToken();
                        StringTokenizer num2_tok=new StringTokenizer(cadena);
                        expresion.add(CUARTOVAR);
                        expresion.add(num2_tok.nextToken());
                        expresion.add("");
                    }

                }
                variables.add(expresion);
            }
            if(cadena.indexOf("ELEMENTVAR")!=-1){
                System.out.println("Un variable de elemento");
                StringTokenizer num_tok=new StringTokenizer(cadena," ");
                String num=new String("");
                Vector expresion=new Vector();
                while(num_tok.hasMoreTokens()){
                    num=num_tok.nextToken();
                    if(num.equals("ELEMENTVAR"));
                    if(num.equals("{") && num_tok.hasMoreTokens()){
                        expresion.add(ELEMENTVAR);
                        expresion.add(num_tok.nextToken());
                        expresion.add("");
                    }
                    if (num.equals("{") && !num_tok.hasMoreTokens()){
                        cadena=st.nextToken();
                        StringTokenizer num2_tok=new StringTokenizer(cadena);
                        expresion.add(ELEMENTVAR);
                        expresion.add(num2_tok.nextToken());
                        expresion.add("");
                    }

                }
                variables.add(expresion);
            }
            //Aqui empiezan las logicas, FOR, IF-THEN-ELSE, WHILE

        }
}
/**
 * Devuelve el icono del elemento.
 * @return Image icono.
 */
public Image getIcono(){
    return icono.getImage();
}
/**
 * Devuelve la imagen del elemento. Sino tiene imagen obtiene el
 * frame de la animacion que este para mostrar.
 * @return Image imagen del elemento.
 */
public Image getImagen(){
    if (animacion!=null){
        return animacion.getImagenEn(animacion.imagenamostrar);
    }else{
        return imagen.getImage();
    }
}
/**
 * Devuelve la posicion del elemento y su escala.
 * @return int[] 0:posicionx 1:posiciony 2:escala
 */
public int[] getPosicion(){
    return posicion;
}
/**
 * Devuelve el inventario de el elemento.
 * @return Vector inventario.
 */
public Vector getElementos(){
    //System.out.println(((Elemento)elementos.elementAt(0)).nombre);
    return elementos;
}
/**
 * Cambia la posicion del elemento.
 * @param x posicion x
 * @param y posicion y
 * @param escala escala.
 */
public void setPosicion(int x, int y, int escala){
    posicion[0]=x;
    posicion[1]=y;
    posicion[2]=escala;
}
/**
 * Metodo clone() util para herencia.
 * @return Elemento copia del actual.
 */
 @Override
    public Elemento clone(){
        Elemento obj=null;
        try{
            obj=(Elemento)super.clone();
        }catch(CloneNotSupportedException ex){
            System.out.println(" no se puede duplicar");
        }
        obj.elementos=(Vector)obj.elementos.clone();
        obj.animacion=(Animacion)obj.animacion.clone();
        obj.acciones=(Vector)obj.acciones.clone();
        obj.variables=(Vector)obj.variables.clone();
        return obj;
    }
}